=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpcoreClient
  class ArtifactsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create an artifact
    # A customized named ModelViewSet that knows how to register itself with the Pulp API router.  This viewset is discoverable by its name. \"Normal\" Django Models and Master/Detail models are supported by the ``register_with`` method.  Attributes:     lookup_field (str): The name of the field by which an object should be looked up, in         addition to any parent lookups if this ViewSet is nested. Defaults to 'pk'     endpoint_name (str): The name of the final path segment that should identify the ViewSet's         collection endpoint.     nest_prefix (str): Optional prefix under which this ViewSet should be nested. This must         correspond to the \"parent_prefix\" of a router with rest_framework_nested.NestedMixin.         None indicates this ViewSet should not be nested.     parent_lookup_kwargs (dict): Optional mapping of key names that would appear in self.kwargs         to django model filter expressions that can be used with the corresponding value from         self.kwargs, used only by a nested ViewSet to filter based on the parent object's         identity.     schema (DefaultSchema): The schema class to use by default in a viewset.
    # @param file [File] The stored file.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :size The size of the file in bytes.
    # @option opts [String] :md5 The MD5 checksum of the file if available.
    # @option opts [String] :sha1 The SHA-1 checksum of the file if available.
    # @option opts [String] :sha224 The SHA-224 checksum of the file if available.
    # @option opts [String] :sha256 The SHA-256 checksum of the file if available.
    # @option opts [String] :sha384 The SHA-384 checksum of the file if available.
    # @option opts [String] :sha512 The SHA-512 checksum of the file if available.
    # @return [ArtifactResponse]
    def create(file, opts = {})
      data, _status_code, _headers = create_with_http_info(file, opts)
      data
    end

    # Create an artifact
    # A customized named ModelViewSet that knows how to register itself with the Pulp API router.  This viewset is discoverable by its name. \&quot;Normal\&quot; Django Models and Master/Detail models are supported by the &#x60;&#x60;register_with&#x60;&#x60; method.  Attributes:     lookup_field (str): The name of the field by which an object should be looked up, in         addition to any parent lookups if this ViewSet is nested. Defaults to &#39;pk&#39;     endpoint_name (str): The name of the final path segment that should identify the ViewSet&#39;s         collection endpoint.     nest_prefix (str): Optional prefix under which this ViewSet should be nested. This must         correspond to the \&quot;parent_prefix\&quot; of a router with rest_framework_nested.NestedMixin.         None indicates this ViewSet should not be nested.     parent_lookup_kwargs (dict): Optional mapping of key names that would appear in self.kwargs         to django model filter expressions that can be used with the corresponding value from         self.kwargs, used only by a nested ViewSet to filter based on the parent object&#39;s         identity.     schema (DefaultSchema): The schema class to use by default in a viewset.
    # @param file [File] The stored file.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :size The size of the file in bytes.
    # @option opts [String] :md5 The MD5 checksum of the file if available.
    # @option opts [String] :sha1 The SHA-1 checksum of the file if available.
    # @option opts [String] :sha224 The SHA-224 checksum of the file if available.
    # @option opts [String] :sha256 The SHA-256 checksum of the file if available.
    # @option opts [String] :sha384 The SHA-384 checksum of the file if available.
    # @option opts [String] :sha512 The SHA-512 checksum of the file if available.
    # @return [Array<(ArtifactResponse, Integer, Hash)>] ArtifactResponse data, response status code and response headers
    def create_with_http_info(file, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ArtifactsApi.create ...'
      end
      # verify the required parameter 'file' is set
      if @api_client.config.client_side_validation && file.nil?
        fail ArgumentError, "Missing the required parameter 'file' when calling ArtifactsApi.create"
      end
      if @api_client.config.client_side_validation && !opts[:'md5'].nil? && opts[:'md5'].to_s.length < 1
        fail ArgumentError, 'invalid value for "opts[:"md5"]" when calling ArtifactsApi.create, the character length must be great than or equal to 1.'
      end

      if @api_client.config.client_side_validation && !opts[:'sha1'].nil? && opts[:'sha1'].to_s.length < 1
        fail ArgumentError, 'invalid value for "opts[:"sha1"]" when calling ArtifactsApi.create, the character length must be great than or equal to 1.'
      end

      if @api_client.config.client_side_validation && !opts[:'sha224'].nil? && opts[:'sha224'].to_s.length < 1
        fail ArgumentError, 'invalid value for "opts[:"sha224"]" when calling ArtifactsApi.create, the character length must be great than or equal to 1.'
      end

      if @api_client.config.client_side_validation && !opts[:'sha256'].nil? && opts[:'sha256'].to_s.length < 1
        fail ArgumentError, 'invalid value for "opts[:"sha256"]" when calling ArtifactsApi.create, the character length must be great than or equal to 1.'
      end

      if @api_client.config.client_side_validation && !opts[:'sha384'].nil? && opts[:'sha384'].to_s.length < 1
        fail ArgumentError, 'invalid value for "opts[:"sha384"]" when calling ArtifactsApi.create, the character length must be great than or equal to 1.'
      end

      if @api_client.config.client_side_validation && !opts[:'sha512'].nil? && opts[:'sha512'].to_s.length < 1
        fail ArgumentError, 'invalid value for "opts[:"sha512"]" when calling ArtifactsApi.create, the character length must be great than or equal to 1.'
      end

      # resource path
      local_var_path = '/pulp/api/v3/artifacts/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['multipart/form-data', 'application/x-www-form-urlencoded'])

      # form parameters
      form_params = opts[:form_params] || {}
      form_params['file'] = file
      form_params['size'] = opts[:'size'] if !opts[:'size'].nil?
      form_params['md5'] = opts[:'md5'] if !opts[:'md5'].nil?
      form_params['sha1'] = opts[:'sha1'] if !opts[:'sha1'].nil?
      form_params['sha224'] = opts[:'sha224'] if !opts[:'sha224'].nil?
      form_params['sha256'] = opts[:'sha256'] if !opts[:'sha256'].nil?
      form_params['sha384'] = opts[:'sha384'] if !opts[:'sha384'].nil?
      form_params['sha512'] = opts[:'sha512'] if !opts[:'sha512'].nil?

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'ArtifactResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ArtifactsApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete an artifact
    # Remove Artifact only if it is not associated with any Content.
    # @param artifact_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete(artifact_href, opts = {})
      delete_with_http_info(artifact_href, opts)
      nil
    end

    # Delete an artifact
    # Remove Artifact only if it is not associated with any Content.
    # @param artifact_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def delete_with_http_info(artifact_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ArtifactsApi.delete ...'
      end
      # verify the required parameter 'artifact_href' is set
      if @api_client.config.client_side_validation && artifact_href.nil?
        fail ArgumentError, "Missing the required parameter 'artifact_href' when calling ArtifactsApi.delete"
      end
      # resource path
      local_var_path = '{artifact_href}'.sub('{' + 'artifact_href' + '}', CGI.escape(artifact_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ArtifactsApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List artifacts
    # A customized named ModelViewSet that knows how to register itself with the Pulp API router.  This viewset is discoverable by its name. \"Normal\" Django Models and Master/Detail models are supported by the ``register_with`` method.  Attributes:     lookup_field (str): The name of the field by which an object should be looked up, in         addition to any parent lookups if this ViewSet is nested. Defaults to 'pk'     endpoint_name (str): The name of the final path segment that should identify the ViewSet's         collection endpoint.     nest_prefix (str): Optional prefix under which this ViewSet should be nested. This must         correspond to the \"parent_prefix\" of a router with rest_framework_nested.NestedMixin.         None indicates this ViewSet should not be nested.     parent_lookup_kwargs (dict): Optional mapping of key names that would appear in self.kwargs         to django model filter expressions that can be used with the corresponding value from         self.kwargs, used only by a nested ViewSet to filter based on the parent object's         identity.     schema (DefaultSchema): The schema class to use by default in a viewset.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :md5 Filter results where md5 matches value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;pulp_id&#x60; - Pulp id * &#x60;-pulp_id&#x60; - Pulp id (descending) * &#x60;pulp_created&#x60; - Pulp created * &#x60;-pulp_created&#x60; - Pulp created (descending) * &#x60;pulp_last_updated&#x60; - Pulp last updated * &#x60;-pulp_last_updated&#x60; - Pulp last updated (descending) * &#x60;file&#x60; - File * &#x60;-file&#x60; - File (descending) * &#x60;size&#x60; - Size * &#x60;-size&#x60; - Size (descending) * &#x60;md5&#x60; - Md5 * &#x60;-md5&#x60; - Md5 (descending) * &#x60;sha1&#x60; - Sha1 * &#x60;-sha1&#x60; - Sha1 (descending) * &#x60;sha224&#x60; - Sha224 * &#x60;-sha224&#x60; - Sha224 (descending) * &#x60;sha256&#x60; - Sha256 * &#x60;-sha256&#x60; - Sha256 (descending) * &#x60;sha384&#x60; - Sha384 * &#x60;-sha384&#x60; - Sha384 (descending) * &#x60;sha512&#x60; - Sha512 * &#x60;-sha512&#x60; - Sha512 (descending) * &#x60;timestamp_of_interest&#x60; - Timestamp of interest * &#x60;-timestamp_of_interest&#x60; - Timestamp of interest (descending) * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [Float] :orphaned_for Minutes Artifacts have been orphaned for. -1 uses ORPHAN_PROTECTION_TIME.
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_id__in Multiple values may be separated by commas.
    # @option opts [String] :q 
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :sha1 Filter results where sha1 matches value
    # @option opts [String] :sha224 Filter results where sha224 matches value
    # @option opts [String] :sha256 Filter results where sha256 matches value
    # @option opts [String] :sha384 Filter results where sha384 matches value
    # @option opts [String] :sha512 Filter results where sha512 matches value
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedArtifactResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List artifacts
    # A customized named ModelViewSet that knows how to register itself with the Pulp API router.  This viewset is discoverable by its name. \&quot;Normal\&quot; Django Models and Master/Detail models are supported by the &#x60;&#x60;register_with&#x60;&#x60; method.  Attributes:     lookup_field (str): The name of the field by which an object should be looked up, in         addition to any parent lookups if this ViewSet is nested. Defaults to &#39;pk&#39;     endpoint_name (str): The name of the final path segment that should identify the ViewSet&#39;s         collection endpoint.     nest_prefix (str): Optional prefix under which this ViewSet should be nested. This must         correspond to the \&quot;parent_prefix\&quot; of a router with rest_framework_nested.NestedMixin.         None indicates this ViewSet should not be nested.     parent_lookup_kwargs (dict): Optional mapping of key names that would appear in self.kwargs         to django model filter expressions that can be used with the corresponding value from         self.kwargs, used only by a nested ViewSet to filter based on the parent object&#39;s         identity.     schema (DefaultSchema): The schema class to use by default in a viewset.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :md5 Filter results where md5 matches value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;pulp_id&#x60; - Pulp id * &#x60;-pulp_id&#x60; - Pulp id (descending) * &#x60;pulp_created&#x60; - Pulp created * &#x60;-pulp_created&#x60; - Pulp created (descending) * &#x60;pulp_last_updated&#x60; - Pulp last updated * &#x60;-pulp_last_updated&#x60; - Pulp last updated (descending) * &#x60;file&#x60; - File * &#x60;-file&#x60; - File (descending) * &#x60;size&#x60; - Size * &#x60;-size&#x60; - Size (descending) * &#x60;md5&#x60; - Md5 * &#x60;-md5&#x60; - Md5 (descending) * &#x60;sha1&#x60; - Sha1 * &#x60;-sha1&#x60; - Sha1 (descending) * &#x60;sha224&#x60; - Sha224 * &#x60;-sha224&#x60; - Sha224 (descending) * &#x60;sha256&#x60; - Sha256 * &#x60;-sha256&#x60; - Sha256 (descending) * &#x60;sha384&#x60; - Sha384 * &#x60;-sha384&#x60; - Sha384 (descending) * &#x60;sha512&#x60; - Sha512 * &#x60;-sha512&#x60; - Sha512 (descending) * &#x60;timestamp_of_interest&#x60; - Timestamp of interest * &#x60;-timestamp_of_interest&#x60; - Timestamp of interest (descending) * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [Float] :orphaned_for Minutes Artifacts have been orphaned for. -1 uses ORPHAN_PROTECTION_TIME.
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_id__in Multiple values may be separated by commas.
    # @option opts [String] :q 
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :sha1 Filter results where sha1 matches value
    # @option opts [String] :sha224 Filter results where sha224 matches value
    # @option opts [String] :sha256 Filter results where sha256 matches value
    # @option opts [String] :sha384 Filter results where sha384 matches value
    # @option opts [String] :sha512 Filter results where sha512 matches value
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedArtifactResponseList, Integer, Hash)>] PaginatedArtifactResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ArtifactsApi.list ...'
      end
      allowable_values = ["-file", "-md5", "-pk", "-pulp_created", "-pulp_id", "-pulp_last_updated", "-sha1", "-sha224", "-sha256", "-sha384", "-sha512", "-size", "-timestamp_of_interest", "file", "md5", "pk", "pulp_created", "pulp_id", "pulp_last_updated", "sha1", "sha224", "sha256", "sha384", "sha512", "size", "timestamp_of_interest"]
      if @api_client.config.client_side_validation && opts[:'ordering'] && !opts[:'ordering'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"ordering\", must include one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/pulp/api/v3/artifacts/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'md5'] = opts[:'md5'] if !opts[:'md5'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = @api_client.build_collection_param(opts[:'ordering'], :csv) if !opts[:'ordering'].nil?
      query_params[:'orphaned_for'] = opts[:'orphaned_for'] if !opts[:'orphaned_for'].nil?
      query_params[:'pulp_href__in'] = @api_client.build_collection_param(opts[:'pulp_href__in'], :csv) if !opts[:'pulp_href__in'].nil?
      query_params[:'pulp_id__in'] = @api_client.build_collection_param(opts[:'pulp_id__in'], :csv) if !opts[:'pulp_id__in'].nil?
      query_params[:'q'] = opts[:'q'] if !opts[:'q'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'sha1'] = opts[:'sha1'] if !opts[:'sha1'].nil?
      query_params[:'sha224'] = opts[:'sha224'] if !opts[:'sha224'].nil?
      query_params[:'sha256'] = opts[:'sha256'] if !opts[:'sha256'].nil?
      query_params[:'sha384'] = opts[:'sha384'] if !opts[:'sha384'].nil?
      query_params[:'sha512'] = opts[:'sha512'] if !opts[:'sha512'].nil?
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedArtifactResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ArtifactsApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect an artifact
    # A customized named ModelViewSet that knows how to register itself with the Pulp API router.  This viewset is discoverable by its name. \"Normal\" Django Models and Master/Detail models are supported by the ``register_with`` method.  Attributes:     lookup_field (str): The name of the field by which an object should be looked up, in         addition to any parent lookups if this ViewSet is nested. Defaults to 'pk'     endpoint_name (str): The name of the final path segment that should identify the ViewSet's         collection endpoint.     nest_prefix (str): Optional prefix under which this ViewSet should be nested. This must         correspond to the \"parent_prefix\" of a router with rest_framework_nested.NestedMixin.         None indicates this ViewSet should not be nested.     parent_lookup_kwargs (dict): Optional mapping of key names that would appear in self.kwargs         to django model filter expressions that can be used with the corresponding value from         self.kwargs, used only by a nested ViewSet to filter based on the parent object's         identity.     schema (DefaultSchema): The schema class to use by default in a viewset.
    # @param artifact_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [ArtifactResponse]
    def read(artifact_href, opts = {})
      data, _status_code, _headers = read_with_http_info(artifact_href, opts)
      data
    end

    # Inspect an artifact
    # A customized named ModelViewSet that knows how to register itself with the Pulp API router.  This viewset is discoverable by its name. \&quot;Normal\&quot; Django Models and Master/Detail models are supported by the &#x60;&#x60;register_with&#x60;&#x60; method.  Attributes:     lookup_field (str): The name of the field by which an object should be looked up, in         addition to any parent lookups if this ViewSet is nested. Defaults to &#39;pk&#39;     endpoint_name (str): The name of the final path segment that should identify the ViewSet&#39;s         collection endpoint.     nest_prefix (str): Optional prefix under which this ViewSet should be nested. This must         correspond to the \&quot;parent_prefix\&quot; of a router with rest_framework_nested.NestedMixin.         None indicates this ViewSet should not be nested.     parent_lookup_kwargs (dict): Optional mapping of key names that would appear in self.kwargs         to django model filter expressions that can be used with the corresponding value from         self.kwargs, used only by a nested ViewSet to filter based on the parent object&#39;s         identity.     schema (DefaultSchema): The schema class to use by default in a viewset.
    # @param artifact_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(ArtifactResponse, Integer, Hash)>] ArtifactResponse data, response status code and response headers
    def read_with_http_info(artifact_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ArtifactsApi.read ...'
      end
      # verify the required parameter 'artifact_href' is set
      if @api_client.config.client_side_validation && artifact_href.nil?
        fail ArgumentError, "Missing the required parameter 'artifact_href' when calling ArtifactsApi.read"
      end
      # resource path
      local_var_path = '{artifact_href}'.sub('{' + 'artifact_href' + '}', CGI.escape(artifact_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'ArtifactResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ArtifactsApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
