=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpcoreClient
  class ExportersFilesystemApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a filesystem exporter
    # Endpoint for managing FilesystemExporters.
    # @param filesystem_exporter [FilesystemExporter] 
    # @param [Hash] opts the optional parameters
    # @return [FilesystemExporterResponse]
    def create(filesystem_exporter, opts = {})
      data, _status_code, _headers = create_with_http_info(filesystem_exporter, opts)
      data
    end

    # Create a filesystem exporter
    # Endpoint for managing FilesystemExporters.
    # @param filesystem_exporter [FilesystemExporter] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(FilesystemExporterResponse, Integer, Hash)>] FilesystemExporterResponse data, response status code and response headers
    def create_with_http_info(filesystem_exporter, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExportersFilesystemApi.create ...'
      end
      # verify the required parameter 'filesystem_exporter' is set
      if @api_client.config.client_side_validation && filesystem_exporter.nil?
        fail ArgumentError, "Missing the required parameter 'filesystem_exporter' when calling ExportersFilesystemApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/exporters/core/filesystem/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(filesystem_exporter) 

      # return_type
      return_type = opts[:return_type] || 'FilesystemExporterResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExportersFilesystemApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a filesystem exporter
    # Trigger an asynchronous delete task
    # @param filesystem_exporter_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def delete(filesystem_exporter_href, opts = {})
      data, _status_code, _headers = delete_with_http_info(filesystem_exporter_href, opts)
      data
    end

    # Delete a filesystem exporter
    # Trigger an asynchronous delete task
    # @param filesystem_exporter_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def delete_with_http_info(filesystem_exporter_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExportersFilesystemApi.delete ...'
      end
      # verify the required parameter 'filesystem_exporter_href' is set
      if @api_client.config.client_side_validation && filesystem_exporter_href.nil?
        fail ArgumentError, "Missing the required parameter 'filesystem_exporter_href' when calling ExportersFilesystemApi.delete"
      end
      # resource path
      local_var_path = '{filesystem_exporter_href}'.sub('{' + 'filesystem_exporter_href' + '}', CGI.escape(filesystem_exporter_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExportersFilesystemApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List filesystem exporters
    # Endpoint for managing FilesystemExporters.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name Filter results where name matches value
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [String] :name__iexact Filter results where name matches value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__iregex Filter results where name matches regex value
    # @option opts [String] :name__istartswith Filter results where name starts with value
    # @option opts [String] :name__regex Filter results where name matches regex value
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;pulp_id&#x60; - Pulp id * &#x60;-pulp_id&#x60; - Pulp id (descending) * &#x60;pulp_created&#x60; - Pulp created * &#x60;-pulp_created&#x60; - Pulp created (descending) * &#x60;pulp_last_updated&#x60; - Pulp last updated * &#x60;-pulp_last_updated&#x60; - Pulp last updated (descending) * &#x60;pulp_type&#x60; - Pulp type * &#x60;-pulp_type&#x60; - Pulp type (descending) * &#x60;name&#x60; - Name * &#x60;-name&#x60; - Name (descending) * &#x60;path&#x60; - Path * &#x60;-path&#x60; - Path (descending) * &#x60;method&#x60; - Method * &#x60;-method&#x60; - Method (descending) * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_id__in Multiple values may be separated by commas.
    # @option opts [String] :q 
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedFilesystemExporterResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List filesystem exporters
    # Endpoint for managing FilesystemExporters.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name Filter results where name matches value
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [String] :name__iexact Filter results where name matches value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__iregex Filter results where name matches regex value
    # @option opts [String] :name__istartswith Filter results where name starts with value
    # @option opts [String] :name__regex Filter results where name matches regex value
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;pulp_id&#x60; - Pulp id * &#x60;-pulp_id&#x60; - Pulp id (descending) * &#x60;pulp_created&#x60; - Pulp created * &#x60;-pulp_created&#x60; - Pulp created (descending) * &#x60;pulp_last_updated&#x60; - Pulp last updated * &#x60;-pulp_last_updated&#x60; - Pulp last updated (descending) * &#x60;pulp_type&#x60; - Pulp type * &#x60;-pulp_type&#x60; - Pulp type (descending) * &#x60;name&#x60; - Name * &#x60;-name&#x60; - Name (descending) * &#x60;path&#x60; - Path * &#x60;-path&#x60; - Path (descending) * &#x60;method&#x60; - Method * &#x60;-method&#x60; - Method (descending) * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_id__in Multiple values may be separated by commas.
    # @option opts [String] :q 
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedFilesystemExporterResponseList, Integer, Hash)>] PaginatedFilesystemExporterResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExportersFilesystemApi.list ...'
      end
      allowable_values = ["-method", "-name", "-path", "-pk", "-pulp_created", "-pulp_id", "-pulp_last_updated", "-pulp_type", "method", "name", "path", "pk", "pulp_created", "pulp_id", "pulp_last_updated", "pulp_type"]
      if @api_client.config.client_side_validation && opts[:'ordering'] && !opts[:'ordering'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"ordering\", must include one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/pulp/api/v3/exporters/core/filesystem/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__contains'] = opts[:'name__contains'] if !opts[:'name__contains'].nil?
      query_params[:'name__icontains'] = opts[:'name__icontains'] if !opts[:'name__icontains'].nil?
      query_params[:'name__iexact'] = opts[:'name__iexact'] if !opts[:'name__iexact'].nil?
      query_params[:'name__in'] = @api_client.build_collection_param(opts[:'name__in'], :csv) if !opts[:'name__in'].nil?
      query_params[:'name__iregex'] = opts[:'name__iregex'] if !opts[:'name__iregex'].nil?
      query_params[:'name__istartswith'] = opts[:'name__istartswith'] if !opts[:'name__istartswith'].nil?
      query_params[:'name__regex'] = opts[:'name__regex'] if !opts[:'name__regex'].nil?
      query_params[:'name__startswith'] = opts[:'name__startswith'] if !opts[:'name__startswith'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = @api_client.build_collection_param(opts[:'ordering'], :csv) if !opts[:'ordering'].nil?
      query_params[:'pulp_href__in'] = @api_client.build_collection_param(opts[:'pulp_href__in'], :csv) if !opts[:'pulp_href__in'].nil?
      query_params[:'pulp_id__in'] = @api_client.build_collection_param(opts[:'pulp_id__in'], :csv) if !opts[:'pulp_id__in'].nil?
      query_params[:'q'] = opts[:'q'] if !opts[:'q'].nil?
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedFilesystemExporterResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExportersFilesystemApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a filesystem exporter
    # Trigger an asynchronous partial update task
    # @param filesystem_exporter_href [String] 
    # @param patched_filesystem_exporter [PatchedFilesystemExporter] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def partial_update(filesystem_exporter_href, patched_filesystem_exporter, opts = {})
      data, _status_code, _headers = partial_update_with_http_info(filesystem_exporter_href, patched_filesystem_exporter, opts)
      data
    end

    # Update a filesystem exporter
    # Trigger an asynchronous partial update task
    # @param filesystem_exporter_href [String] 
    # @param patched_filesystem_exporter [PatchedFilesystemExporter] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def partial_update_with_http_info(filesystem_exporter_href, patched_filesystem_exporter, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExportersFilesystemApi.partial_update ...'
      end
      # verify the required parameter 'filesystem_exporter_href' is set
      if @api_client.config.client_side_validation && filesystem_exporter_href.nil?
        fail ArgumentError, "Missing the required parameter 'filesystem_exporter_href' when calling ExportersFilesystemApi.partial_update"
      end
      # verify the required parameter 'patched_filesystem_exporter' is set
      if @api_client.config.client_side_validation && patched_filesystem_exporter.nil?
        fail ArgumentError, "Missing the required parameter 'patched_filesystem_exporter' when calling ExportersFilesystemApi.partial_update"
      end
      # resource path
      local_var_path = '{filesystem_exporter_href}'.sub('{' + 'filesystem_exporter_href' + '}', CGI.escape(filesystem_exporter_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(patched_filesystem_exporter) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExportersFilesystemApi#partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a filesystem exporter
    # Endpoint for managing FilesystemExporters.
    # @param filesystem_exporter_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [FilesystemExporterResponse]
    def read(filesystem_exporter_href, opts = {})
      data, _status_code, _headers = read_with_http_info(filesystem_exporter_href, opts)
      data
    end

    # Inspect a filesystem exporter
    # Endpoint for managing FilesystemExporters.
    # @param filesystem_exporter_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(FilesystemExporterResponse, Integer, Hash)>] FilesystemExporterResponse data, response status code and response headers
    def read_with_http_info(filesystem_exporter_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExportersFilesystemApi.read ...'
      end
      # verify the required parameter 'filesystem_exporter_href' is set
      if @api_client.config.client_side_validation && filesystem_exporter_href.nil?
        fail ArgumentError, "Missing the required parameter 'filesystem_exporter_href' when calling ExportersFilesystemApi.read"
      end
      # resource path
      local_var_path = '{filesystem_exporter_href}'.sub('{' + 'filesystem_exporter_href' + '}', CGI.escape(filesystem_exporter_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'FilesystemExporterResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExportersFilesystemApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a filesystem exporter
    # Trigger an asynchronous update task
    # @param filesystem_exporter_href [String] 
    # @param filesystem_exporter [FilesystemExporter] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def update(filesystem_exporter_href, filesystem_exporter, opts = {})
      data, _status_code, _headers = update_with_http_info(filesystem_exporter_href, filesystem_exporter, opts)
      data
    end

    # Update a filesystem exporter
    # Trigger an asynchronous update task
    # @param filesystem_exporter_href [String] 
    # @param filesystem_exporter [FilesystemExporter] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def update_with_http_info(filesystem_exporter_href, filesystem_exporter, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExportersFilesystemApi.update ...'
      end
      # verify the required parameter 'filesystem_exporter_href' is set
      if @api_client.config.client_side_validation && filesystem_exporter_href.nil?
        fail ArgumentError, "Missing the required parameter 'filesystem_exporter_href' when calling ExportersFilesystemApi.update"
      end
      # verify the required parameter 'filesystem_exporter' is set
      if @api_client.config.client_side_validation && filesystem_exporter.nil?
        fail ArgumentError, "Missing the required parameter 'filesystem_exporter' when calling ExportersFilesystemApi.update"
      end
      # resource path
      local_var_path = '{filesystem_exporter_href}'.sub('{' + 'filesystem_exporter_href' + '}', CGI.escape(filesystem_exporter_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(filesystem_exporter) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExportersFilesystemApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
