=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpcoreClient
  class GroupsRolesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a group role
    # ViewSet for GroupRole.
    # @param group_href [String] 
    # @param group_role [GroupRole] 
    # @param [Hash] opts the optional parameters
    # @return [GroupRoleResponse]
    def create(group_href, group_role, opts = {})
      data, _status_code, _headers = create_with_http_info(group_href, group_role, opts)
      data
    end

    # Create a group role
    # ViewSet for GroupRole.
    # @param group_href [String] 
    # @param group_role [GroupRole] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(GroupRoleResponse, Integer, Hash)>] GroupRoleResponse data, response status code and response headers
    def create_with_http_info(group_href, group_role, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: GroupsRolesApi.create ...'
      end
      # verify the required parameter 'group_href' is set
      if @api_client.config.client_side_validation && group_href.nil?
        fail ArgumentError, "Missing the required parameter 'group_href' when calling GroupsRolesApi.create"
      end
      # verify the required parameter 'group_role' is set
      if @api_client.config.client_side_validation && group_role.nil?
        fail ArgumentError, "Missing the required parameter 'group_role' when calling GroupsRolesApi.create"
      end
      # resource path
      local_var_path = '{group_href}roles/'.sub('{' + 'group_href' + '}', CGI.escape(group_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(group_role) 

      # return_type
      return_type = opts[:return_type] || 'GroupRoleResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: GroupsRolesApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a group role
    # ViewSet for GroupRole.
    # @param groups_group_role_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete(groups_group_role_href, opts = {})
      delete_with_http_info(groups_group_role_href, opts)
      nil
    end

    # Delete a group role
    # ViewSet for GroupRole.
    # @param groups_group_role_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def delete_with_http_info(groups_group_role_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: GroupsRolesApi.delete ...'
      end
      # verify the required parameter 'groups_group_role_href' is set
      if @api_client.config.client_side_validation && groups_group_role_href.nil?
        fail ArgumentError, "Missing the required parameter 'groups_group_role_href' when calling GroupsRolesApi.delete"
      end
      # resource path
      local_var_path = '{groups_group_role_href}'.sub('{' + 'groups_group_role_href' + '}', CGI.escape(groups_group_role_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: GroupsRolesApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List group roles
    # ViewSet for GroupRole.
    # @param group_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :content_object content_object
    # @option opts [String] :domain Foreign Key referenced by HREF
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;role&#x60; - Role * &#x60;-role&#x60; - Role (descending) * &#x60;description&#x60; - Description * &#x60;-description&#x60; - Description (descending) * &#x60;pulp_created&#x60; - Pulp created * &#x60;-pulp_created&#x60; - Pulp created (descending) * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_id__in Multiple values may be separated by commas.
    # @option opts [String] :q 
    # @option opts [String] :role 
    # @option opts [String] :role__contains 
    # @option opts [String] :role__icontains 
    # @option opts [Array<String>] :role__in Multiple values may be separated by commas.
    # @option opts [String] :role__startswith 
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedGroupRoleResponseList]
    def list(group_href, opts = {})
      data, _status_code, _headers = list_with_http_info(group_href, opts)
      data
    end

    # List group roles
    # ViewSet for GroupRole.
    # @param group_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :content_object content_object
    # @option opts [String] :domain Foreign Key referenced by HREF
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;role&#x60; - Role * &#x60;-role&#x60; - Role (descending) * &#x60;description&#x60; - Description * &#x60;-description&#x60; - Description (descending) * &#x60;pulp_created&#x60; - Pulp created * &#x60;-pulp_created&#x60; - Pulp created (descending) * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_id__in Multiple values may be separated by commas.
    # @option opts [String] :q 
    # @option opts [String] :role 
    # @option opts [String] :role__contains 
    # @option opts [String] :role__icontains 
    # @option opts [Array<String>] :role__in Multiple values may be separated by commas.
    # @option opts [String] :role__startswith 
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedGroupRoleResponseList, Integer, Hash)>] PaginatedGroupRoleResponseList data, response status code and response headers
    def list_with_http_info(group_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: GroupsRolesApi.list ...'
      end
      # verify the required parameter 'group_href' is set
      if @api_client.config.client_side_validation && group_href.nil?
        fail ArgumentError, "Missing the required parameter 'group_href' when calling GroupsRolesApi.list"
      end
      allowable_values = ["-description", "-pk", "-pulp_created", "-role", "description", "pk", "pulp_created", "role"]
      if @api_client.config.client_side_validation && opts[:'ordering'] && !opts[:'ordering'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"ordering\", must include one of #{allowable_values}"
      end
      # resource path
      local_var_path = '{group_href}roles/'.sub('{' + 'group_href' + '}', CGI.escape(group_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'content_object'] = opts[:'content_object'] if !opts[:'content_object'].nil?
      query_params[:'domain'] = opts[:'domain'] if !opts[:'domain'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = @api_client.build_collection_param(opts[:'ordering'], :csv) if !opts[:'ordering'].nil?
      query_params[:'pulp_href__in'] = @api_client.build_collection_param(opts[:'pulp_href__in'], :csv) if !opts[:'pulp_href__in'].nil?
      query_params[:'pulp_id__in'] = @api_client.build_collection_param(opts[:'pulp_id__in'], :csv) if !opts[:'pulp_id__in'].nil?
      query_params[:'q'] = opts[:'q'] if !opts[:'q'].nil?
      query_params[:'role'] = opts[:'role'] if !opts[:'role'].nil?
      query_params[:'role__contains'] = opts[:'role__contains'] if !opts[:'role__contains'].nil?
      query_params[:'role__icontains'] = opts[:'role__icontains'] if !opts[:'role__icontains'].nil?
      query_params[:'role__in'] = @api_client.build_collection_param(opts[:'role__in'], :csv) if !opts[:'role__in'].nil?
      query_params[:'role__startswith'] = opts[:'role__startswith'] if !opts[:'role__startswith'].nil?
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedGroupRoleResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: GroupsRolesApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a group role
    # ViewSet for GroupRole.
    # @param groups_group_role_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [GroupRoleResponse]
    def read(groups_group_role_href, opts = {})
      data, _status_code, _headers = read_with_http_info(groups_group_role_href, opts)
      data
    end

    # Inspect a group role
    # ViewSet for GroupRole.
    # @param groups_group_role_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(GroupRoleResponse, Integer, Hash)>] GroupRoleResponse data, response status code and response headers
    def read_with_http_info(groups_group_role_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: GroupsRolesApi.read ...'
      end
      # verify the required parameter 'groups_group_role_href' is set
      if @api_client.config.client_side_validation && groups_group_role_href.nil?
        fail ArgumentError, "Missing the required parameter 'groups_group_role_href' when calling GroupsRolesApi.read"
      end
      # resource path
      local_var_path = '{groups_group_role_href}'.sub('{' + 'groups_group_role_href' + '}', CGI.escape(groups_group_role_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'GroupRoleResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: GroupsRolesApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
