=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpcoreClient
  class PublicationsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # List publications
    # A base class for any publication viewset.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :content Content Unit referenced by HREF
    # @option opts [String] :content__in Content Unit referenced by HREF
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;pulp_id&#x60; - Pulp id * &#x60;-pulp_id&#x60; - Pulp id (descending) * &#x60;pulp_created&#x60; - Pulp created * &#x60;-pulp_created&#x60; - Pulp created (descending) * &#x60;pulp_last_updated&#x60; - Pulp last updated * &#x60;-pulp_last_updated&#x60; - Pulp last updated (descending) * &#x60;pulp_type&#x60; - Pulp type * &#x60;-pulp_type&#x60; - Pulp type (descending) * &#x60;complete&#x60; - Complete * &#x60;-complete&#x60; - Complete (descending) * &#x60;pass_through&#x60; - Pass through * &#x60;-pass_through&#x60; - Pass through (descending) * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [DateTime] :pulp_created Filter results where pulp_created matches value
    # @option opts [DateTime] :pulp_created__gt Filter results where pulp_created is greater than value
    # @option opts [DateTime] :pulp_created__gte Filter results where pulp_created is greater than or equal to value
    # @option opts [DateTime] :pulp_created__lt Filter results where pulp_created is less than value
    # @option opts [DateTime] :pulp_created__lte Filter results where pulp_created is less than or equal to value
    # @option opts [Array<DateTime>] :pulp_created__range Filter results where pulp_created is between two comma separated values
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_id__in Multiple values may be separated by commas.
    # @option opts [String] :pulp_type Pulp type  * &#x60;file.file&#x60; - file.file
    # @option opts [Array<String>] :pulp_type__in Multiple values may be separated by commas.  * &#x60;file.file&#x60; - file.file
    # @option opts [String] :q 
    # @option opts [String] :repository Repository referenced by HREF
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedPublicationResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List publications
    # A base class for any publication viewset.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :content Content Unit referenced by HREF
    # @option opts [String] :content__in Content Unit referenced by HREF
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;pulp_id&#x60; - Pulp id * &#x60;-pulp_id&#x60; - Pulp id (descending) * &#x60;pulp_created&#x60; - Pulp created * &#x60;-pulp_created&#x60; - Pulp created (descending) * &#x60;pulp_last_updated&#x60; - Pulp last updated * &#x60;-pulp_last_updated&#x60; - Pulp last updated (descending) * &#x60;pulp_type&#x60; - Pulp type * &#x60;-pulp_type&#x60; - Pulp type (descending) * &#x60;complete&#x60; - Complete * &#x60;-complete&#x60; - Complete (descending) * &#x60;pass_through&#x60; - Pass through * &#x60;-pass_through&#x60; - Pass through (descending) * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [DateTime] :pulp_created Filter results where pulp_created matches value
    # @option opts [DateTime] :pulp_created__gt Filter results where pulp_created is greater than value
    # @option opts [DateTime] :pulp_created__gte Filter results where pulp_created is greater than or equal to value
    # @option opts [DateTime] :pulp_created__lt Filter results where pulp_created is less than value
    # @option opts [DateTime] :pulp_created__lte Filter results where pulp_created is less than or equal to value
    # @option opts [Array<DateTime>] :pulp_created__range Filter results where pulp_created is between two comma separated values
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_id__in Multiple values may be separated by commas.
    # @option opts [String] :pulp_type Pulp type  * &#x60;file.file&#x60; - file.file
    # @option opts [Array<String>] :pulp_type__in Multiple values may be separated by commas.  * &#x60;file.file&#x60; - file.file
    # @option opts [String] :q 
    # @option opts [String] :repository Repository referenced by HREF
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedPublicationResponseList, Integer, Hash)>] PaginatedPublicationResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PublicationsApi.list ...'
      end
      allowable_values = ["-complete", "-pass_through", "-pk", "-pulp_created", "-pulp_id", "-pulp_last_updated", "-pulp_type", "complete", "pass_through", "pk", "pulp_created", "pulp_id", "pulp_last_updated", "pulp_type"]
      if @api_client.config.client_side_validation && opts[:'ordering'] && !opts[:'ordering'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"ordering\", must include one of #{allowable_values}"
      end
      allowable_values = ["file.file"]
      if @api_client.config.client_side_validation && opts[:'pulp_type'] && !allowable_values.include?(opts[:'pulp_type'])
        fail ArgumentError, "invalid value for \"pulp_type\", must be one of #{allowable_values}"
      end
      allowable_values = ["file.file"]
      if @api_client.config.client_side_validation && opts[:'pulp_type__in'] && !opts[:'pulp_type__in'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"pulp_type__in\", must include one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/pulp/api/v3/publications/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'content'] = opts[:'content'] if !opts[:'content'].nil?
      query_params[:'content__in'] = opts[:'content__in'] if !opts[:'content__in'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = @api_client.build_collection_param(opts[:'ordering'], :csv) if !opts[:'ordering'].nil?
      query_params[:'pulp_created'] = opts[:'pulp_created'] if !opts[:'pulp_created'].nil?
      query_params[:'pulp_created__gt'] = opts[:'pulp_created__gt'] if !opts[:'pulp_created__gt'].nil?
      query_params[:'pulp_created__gte'] = opts[:'pulp_created__gte'] if !opts[:'pulp_created__gte'].nil?
      query_params[:'pulp_created__lt'] = opts[:'pulp_created__lt'] if !opts[:'pulp_created__lt'].nil?
      query_params[:'pulp_created__lte'] = opts[:'pulp_created__lte'] if !opts[:'pulp_created__lte'].nil?
      query_params[:'pulp_created__range'] = @api_client.build_collection_param(opts[:'pulp_created__range'], :csv) if !opts[:'pulp_created__range'].nil?
      query_params[:'pulp_href__in'] = @api_client.build_collection_param(opts[:'pulp_href__in'], :csv) if !opts[:'pulp_href__in'].nil?
      query_params[:'pulp_id__in'] = @api_client.build_collection_param(opts[:'pulp_id__in'], :csv) if !opts[:'pulp_id__in'].nil?
      query_params[:'pulp_type'] = opts[:'pulp_type'] if !opts[:'pulp_type'].nil?
      query_params[:'pulp_type__in'] = @api_client.build_collection_param(opts[:'pulp_type__in'], :csv) if !opts[:'pulp_type__in'].nil?
      query_params[:'q'] = opts[:'q'] if !opts[:'q'].nil?
      query_params[:'repository'] = opts[:'repository'] if !opts[:'repository'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedPublicationResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PublicationsApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
