=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpcoreClient
  class UpstreamPulpsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Add a role
    # Add a role for this object to users/groups.
    # @param upstream_pulp_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [NestedRoleResponse]
    def add_role(upstream_pulp_href, nested_role, opts = {})
      data, _status_code, _headers = add_role_with_http_info(upstream_pulp_href, nested_role, opts)
      data
    end

    # Add a role
    # Add a role for this object to users/groups.
    # @param upstream_pulp_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(NestedRoleResponse, Integer, Hash)>] NestedRoleResponse data, response status code and response headers
    def add_role_with_http_info(upstream_pulp_href, nested_role, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UpstreamPulpsApi.add_role ...'
      end
      # verify the required parameter 'upstream_pulp_href' is set
      if @api_client.config.client_side_validation && upstream_pulp_href.nil?
        fail ArgumentError, "Missing the required parameter 'upstream_pulp_href' when calling UpstreamPulpsApi.add_role"
      end
      # verify the required parameter 'nested_role' is set
      if @api_client.config.client_side_validation && nested_role.nil?
        fail ArgumentError, "Missing the required parameter 'nested_role' when calling UpstreamPulpsApi.add_role"
      end
      # resource path
      local_var_path = '{upstream_pulp_href}add_role/'.sub('{' + 'upstream_pulp_href' + '}', CGI.escape(upstream_pulp_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(nested_role) 

      # return_type
      return_type = opts[:return_type] || 'NestedRoleResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UpstreamPulpsApi#add_role\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create an upstream pulp
    # API for configuring an upstream Pulp to replicate. This API is provided as a tech preview.
    # @param upstream_pulp [UpstreamPulp] 
    # @param [Hash] opts the optional parameters
    # @return [UpstreamPulpResponse]
    def create(upstream_pulp, opts = {})
      data, _status_code, _headers = create_with_http_info(upstream_pulp, opts)
      data
    end

    # Create an upstream pulp
    # API for configuring an upstream Pulp to replicate. This API is provided as a tech preview.
    # @param upstream_pulp [UpstreamPulp] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(UpstreamPulpResponse, Integer, Hash)>] UpstreamPulpResponse data, response status code and response headers
    def create_with_http_info(upstream_pulp, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UpstreamPulpsApi.create ...'
      end
      # verify the required parameter 'upstream_pulp' is set
      if @api_client.config.client_side_validation && upstream_pulp.nil?
        fail ArgumentError, "Missing the required parameter 'upstream_pulp' when calling UpstreamPulpsApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/upstream-pulps/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(upstream_pulp) 

      # return_type
      return_type = opts[:return_type] || 'UpstreamPulpResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UpstreamPulpsApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete an upstream pulp
    # API for configuring an upstream Pulp to replicate. This API is provided as a tech preview.
    # @param upstream_pulp_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete(upstream_pulp_href, opts = {})
      delete_with_http_info(upstream_pulp_href, opts)
      nil
    end

    # Delete an upstream pulp
    # API for configuring an upstream Pulp to replicate. This API is provided as a tech preview.
    # @param upstream_pulp_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def delete_with_http_info(upstream_pulp_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UpstreamPulpsApi.delete ...'
      end
      # verify the required parameter 'upstream_pulp_href' is set
      if @api_client.config.client_side_validation && upstream_pulp_href.nil?
        fail ArgumentError, "Missing the required parameter 'upstream_pulp_href' when calling UpstreamPulpsApi.delete"
      end
      # resource path
      local_var_path = '{upstream_pulp_href}'.sub('{' + 'upstream_pulp_href' + '}', CGI.escape(upstream_pulp_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UpstreamPulpsApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List upstream pulps
    # API for configuring an upstream Pulp to replicate. This API is provided as a tech preview.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedUpstreamPulpResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List upstream pulps
    # API for configuring an upstream Pulp to replicate. This API is provided as a tech preview.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedUpstreamPulpResponseList, Integer, Hash)>] PaginatedUpstreamPulpResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UpstreamPulpsApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/upstream-pulps/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedUpstreamPulpResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UpstreamPulpsApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List roles
    # List roles assigned to this object.
    # @param upstream_pulp_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [ObjectRolesResponse]
    def list_roles(upstream_pulp_href, opts = {})
      data, _status_code, _headers = list_roles_with_http_info(upstream_pulp_href, opts)
      data
    end

    # List roles
    # List roles assigned to this object.
    # @param upstream_pulp_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(ObjectRolesResponse, Integer, Hash)>] ObjectRolesResponse data, response status code and response headers
    def list_roles_with_http_info(upstream_pulp_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UpstreamPulpsApi.list_roles ...'
      end
      # verify the required parameter 'upstream_pulp_href' is set
      if @api_client.config.client_side_validation && upstream_pulp_href.nil?
        fail ArgumentError, "Missing the required parameter 'upstream_pulp_href' when calling UpstreamPulpsApi.list_roles"
      end
      # resource path
      local_var_path = '{upstream_pulp_href}list_roles/'.sub('{' + 'upstream_pulp_href' + '}', CGI.escape(upstream_pulp_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'ObjectRolesResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UpstreamPulpsApi#list_roles\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List user permissions
    # List permissions available to the current user on this object.
    # @param upstream_pulp_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [MyPermissionsResponse]
    def my_permissions(upstream_pulp_href, opts = {})
      data, _status_code, _headers = my_permissions_with_http_info(upstream_pulp_href, opts)
      data
    end

    # List user permissions
    # List permissions available to the current user on this object.
    # @param upstream_pulp_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(MyPermissionsResponse, Integer, Hash)>] MyPermissionsResponse data, response status code and response headers
    def my_permissions_with_http_info(upstream_pulp_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UpstreamPulpsApi.my_permissions ...'
      end
      # verify the required parameter 'upstream_pulp_href' is set
      if @api_client.config.client_side_validation && upstream_pulp_href.nil?
        fail ArgumentError, "Missing the required parameter 'upstream_pulp_href' when calling UpstreamPulpsApi.my_permissions"
      end
      # resource path
      local_var_path = '{upstream_pulp_href}my_permissions/'.sub('{' + 'upstream_pulp_href' + '}', CGI.escape(upstream_pulp_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'MyPermissionsResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UpstreamPulpsApi#my_permissions\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update an upstream pulp
    # API for configuring an upstream Pulp to replicate. This API is provided as a tech preview.
    # @param upstream_pulp_href [String] 
    # @param patched_upstream_pulp [PatchedUpstreamPulp] 
    # @param [Hash] opts the optional parameters
    # @return [UpstreamPulpResponse]
    def partial_update(upstream_pulp_href, patched_upstream_pulp, opts = {})
      data, _status_code, _headers = partial_update_with_http_info(upstream_pulp_href, patched_upstream_pulp, opts)
      data
    end

    # Update an upstream pulp
    # API for configuring an upstream Pulp to replicate. This API is provided as a tech preview.
    # @param upstream_pulp_href [String] 
    # @param patched_upstream_pulp [PatchedUpstreamPulp] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(UpstreamPulpResponse, Integer, Hash)>] UpstreamPulpResponse data, response status code and response headers
    def partial_update_with_http_info(upstream_pulp_href, patched_upstream_pulp, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UpstreamPulpsApi.partial_update ...'
      end
      # verify the required parameter 'upstream_pulp_href' is set
      if @api_client.config.client_side_validation && upstream_pulp_href.nil?
        fail ArgumentError, "Missing the required parameter 'upstream_pulp_href' when calling UpstreamPulpsApi.partial_update"
      end
      # verify the required parameter 'patched_upstream_pulp' is set
      if @api_client.config.client_side_validation && patched_upstream_pulp.nil?
        fail ArgumentError, "Missing the required parameter 'patched_upstream_pulp' when calling UpstreamPulpsApi.partial_update"
      end
      # resource path
      local_var_path = '{upstream_pulp_href}'.sub('{' + 'upstream_pulp_href' + '}', CGI.escape(upstream_pulp_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(patched_upstream_pulp) 

      # return_type
      return_type = opts[:return_type] || 'UpstreamPulpResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UpstreamPulpsApi#partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect an upstream pulp
    # API for configuring an upstream Pulp to replicate. This API is provided as a tech preview.
    # @param upstream_pulp_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [UpstreamPulpResponse]
    def read(upstream_pulp_href, opts = {})
      data, _status_code, _headers = read_with_http_info(upstream_pulp_href, opts)
      data
    end

    # Inspect an upstream pulp
    # API for configuring an upstream Pulp to replicate. This API is provided as a tech preview.
    # @param upstream_pulp_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(UpstreamPulpResponse, Integer, Hash)>] UpstreamPulpResponse data, response status code and response headers
    def read_with_http_info(upstream_pulp_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UpstreamPulpsApi.read ...'
      end
      # verify the required parameter 'upstream_pulp_href' is set
      if @api_client.config.client_side_validation && upstream_pulp_href.nil?
        fail ArgumentError, "Missing the required parameter 'upstream_pulp_href' when calling UpstreamPulpsApi.read"
      end
      # resource path
      local_var_path = '{upstream_pulp_href}'.sub('{' + 'upstream_pulp_href' + '}', CGI.escape(upstream_pulp_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'UpstreamPulpResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UpstreamPulpsApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Remove a role
    # Remove a role for this object from users/groups.
    # @param upstream_pulp_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [NestedRoleResponse]
    def remove_role(upstream_pulp_href, nested_role, opts = {})
      data, _status_code, _headers = remove_role_with_http_info(upstream_pulp_href, nested_role, opts)
      data
    end

    # Remove a role
    # Remove a role for this object from users/groups.
    # @param upstream_pulp_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(NestedRoleResponse, Integer, Hash)>] NestedRoleResponse data, response status code and response headers
    def remove_role_with_http_info(upstream_pulp_href, nested_role, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UpstreamPulpsApi.remove_role ...'
      end
      # verify the required parameter 'upstream_pulp_href' is set
      if @api_client.config.client_side_validation && upstream_pulp_href.nil?
        fail ArgumentError, "Missing the required parameter 'upstream_pulp_href' when calling UpstreamPulpsApi.remove_role"
      end
      # verify the required parameter 'nested_role' is set
      if @api_client.config.client_side_validation && nested_role.nil?
        fail ArgumentError, "Missing the required parameter 'nested_role' when calling UpstreamPulpsApi.remove_role"
      end
      # resource path
      local_var_path = '{upstream_pulp_href}remove_role/'.sub('{' + 'upstream_pulp_href' + '}', CGI.escape(upstream_pulp_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(nested_role) 

      # return_type
      return_type = opts[:return_type] || 'NestedRoleResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UpstreamPulpsApi#remove_role\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Replicate
    # Trigger an asynchronous repository replication task group. This API is provided as a tech preview.
    # @param upstream_pulp_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [TaskGroupOperationResponse]
    def replicate(upstream_pulp_href, opts = {})
      data, _status_code, _headers = replicate_with_http_info(upstream_pulp_href, opts)
      data
    end

    # Replicate
    # Trigger an asynchronous repository replication task group. This API is provided as a tech preview.
    # @param upstream_pulp_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(TaskGroupOperationResponse, Integer, Hash)>] TaskGroupOperationResponse data, response status code and response headers
    def replicate_with_http_info(upstream_pulp_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UpstreamPulpsApi.replicate ...'
      end
      # verify the required parameter 'upstream_pulp_href' is set
      if @api_client.config.client_side_validation && upstream_pulp_href.nil?
        fail ArgumentError, "Missing the required parameter 'upstream_pulp_href' when calling UpstreamPulpsApi.replicate"
      end
      # resource path
      local_var_path = '{upstream_pulp_href}replicate/'.sub('{' + 'upstream_pulp_href' + '}', CGI.escape(upstream_pulp_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'TaskGroupOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UpstreamPulpsApi#replicate\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update an upstream pulp
    # API for configuring an upstream Pulp to replicate. This API is provided as a tech preview.
    # @param upstream_pulp_href [String] 
    # @param upstream_pulp [UpstreamPulp] 
    # @param [Hash] opts the optional parameters
    # @return [UpstreamPulpResponse]
    def update(upstream_pulp_href, upstream_pulp, opts = {})
      data, _status_code, _headers = update_with_http_info(upstream_pulp_href, upstream_pulp, opts)
      data
    end

    # Update an upstream pulp
    # API for configuring an upstream Pulp to replicate. This API is provided as a tech preview.
    # @param upstream_pulp_href [String] 
    # @param upstream_pulp [UpstreamPulp] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(UpstreamPulpResponse, Integer, Hash)>] UpstreamPulpResponse data, response status code and response headers
    def update_with_http_info(upstream_pulp_href, upstream_pulp, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UpstreamPulpsApi.update ...'
      end
      # verify the required parameter 'upstream_pulp_href' is set
      if @api_client.config.client_side_validation && upstream_pulp_href.nil?
        fail ArgumentError, "Missing the required parameter 'upstream_pulp_href' when calling UpstreamPulpsApi.update"
      end
      # verify the required parameter 'upstream_pulp' is set
      if @api_client.config.client_side_validation && upstream_pulp.nil?
        fail ArgumentError, "Missing the required parameter 'upstream_pulp' when calling UpstreamPulpsApi.update"
      end
      # resource path
      local_var_path = '{upstream_pulp_href}'.sub('{' + 'upstream_pulp_href' + '}', CGI.escape(upstream_pulp_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(upstream_pulp) 

      # return_type
      return_type = opts[:return_type] || 'UpstreamPulpResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UpstreamPulpsApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
