=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'date'

module PulpcoreClient
  # Serializer for AccessPolicy.
  class AccessPolicyResponse
    attr_accessor :pulp_href

    # Timestamp of creation.
    attr_accessor :pulp_created

    # Timestamp of the last time this resource was updated. Note: for immutable resources - like content, repository versions, and publication - pulp_created and pulp_last_updated dates will be the same.
    attr_accessor :pulp_last_updated

    # List of callables that define the new permissions to be created for new objects.This is deprecated. Use `creation_hooks` instead.
    attr_accessor :permissions_assignment

    # List of callables that may associate user roles for new objects.
    attr_accessor :creation_hooks

    # List of policy statements defining the policy.
    attr_accessor :statements

    # The name of ViewSet this AccessPolicy authorizes.
    attr_accessor :viewset_name

    # True if the AccessPolicy has been user-modified. False otherwise.
    attr_accessor :customized

    # A callable for performing queryset scoping. See plugin documentation for valid callables. Set to blank to turn off queryset scoping.
    attr_accessor :queryset_scoping

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'pulp_href' => :'pulp_href',
        :'pulp_created' => :'pulp_created',
        :'pulp_last_updated' => :'pulp_last_updated',
        :'permissions_assignment' => :'permissions_assignment',
        :'creation_hooks' => :'creation_hooks',
        :'statements' => :'statements',
        :'viewset_name' => :'viewset_name',
        :'customized' => :'customized',
        :'queryset_scoping' => :'queryset_scoping'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'pulp_href' => :'String',
        :'pulp_created' => :'DateTime',
        :'pulp_last_updated' => :'DateTime',
        :'permissions_assignment' => :'Array<Object>',
        :'creation_hooks' => :'Array<Object>',
        :'statements' => :'Array<Object>',
        :'viewset_name' => :'String',
        :'customized' => :'Boolean',
        :'queryset_scoping' => :'Object'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `PulpcoreClient::AccessPolicyResponse` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `PulpcoreClient::AccessPolicyResponse`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'pulp_href')
        self.pulp_href = attributes[:'pulp_href']
      end

      if attributes.key?(:'pulp_created')
        self.pulp_created = attributes[:'pulp_created']
      end

      if attributes.key?(:'pulp_last_updated')
        self.pulp_last_updated = attributes[:'pulp_last_updated']
      end

      if attributes.key?(:'permissions_assignment')
        if (value = attributes[:'permissions_assignment']).is_a?(Array)
          self.permissions_assignment = value
        end
      end

      if attributes.key?(:'creation_hooks')
        if (value = attributes[:'creation_hooks']).is_a?(Array)
          self.creation_hooks = value
        end
      end

      if attributes.key?(:'statements')
        if (value = attributes[:'statements']).is_a?(Array)
          self.statements = value
        end
      end

      if attributes.key?(:'viewset_name')
        self.viewset_name = attributes[:'viewset_name']
      end

      if attributes.key?(:'customized')
        self.customized = attributes[:'customized']
      end

      if attributes.key?(:'queryset_scoping')
        self.queryset_scoping = attributes[:'queryset_scoping']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @statements.nil?
        invalid_properties.push('invalid value for "statements", statements cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @statements.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          pulp_href == o.pulp_href &&
          pulp_created == o.pulp_created &&
          pulp_last_updated == o.pulp_last_updated &&
          permissions_assignment == o.permissions_assignment &&
          creation_hooks == o.creation_hooks &&
          statements == o.statements &&
          viewset_name == o.viewset_name &&
          customized == o.customized &&
          queryset_scoping == o.queryset_scoping
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [pulp_href, pulp_created, pulp_last_updated, permissions_assignment, creation_hooks, statements, viewset_name, customized, queryset_scoping].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        PulpcoreClient.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
