=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'date'

module PulpcoreClient
  # Serializer for a Server.
  class UpstreamPulp
    # A unique name for this Pulp server.
    attr_accessor :name

    # The transport, hostname, and an optional port of the Pulp server. e.g. https://example.com
    attr_accessor :base_url

    # The API root. Defaults to '/pulp/'.
    attr_accessor :api_root

    # The domain of the Pulp server if enabled.
    attr_accessor :domain

    # A PEM encoded CA certificate used to validate the server certificate presented by the remote server.
    attr_accessor :ca_cert

    # A PEM encoded client certificate used for authentication.
    attr_accessor :client_cert

    # A PEM encoded private key used for authentication.
    attr_accessor :client_key

    # If True, TLS peer validation must be performed.
    attr_accessor :tls_validation

    # The username to be used for authentication when syncing.
    attr_accessor :username

    # The password to be used for authentication when syncing. Extra leading and trailing whitespace characters are not trimmed.
    attr_accessor :password

    # One or more comma separated labels that will be used to filter distributions on the upstream Pulp. E.g. \"foo=bar,key=val\" or \"foo,key\"
    attr_accessor :pulp_label_select

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'name' => :'name',
        :'base_url' => :'base_url',
        :'api_root' => :'api_root',
        :'domain' => :'domain',
        :'ca_cert' => :'ca_cert',
        :'client_cert' => :'client_cert',
        :'client_key' => :'client_key',
        :'tls_validation' => :'tls_validation',
        :'username' => :'username',
        :'password' => :'password',
        :'pulp_label_select' => :'pulp_label_select'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'name' => :'String',
        :'base_url' => :'String',
        :'api_root' => :'String',
        :'domain' => :'String',
        :'ca_cert' => :'String',
        :'client_cert' => :'String',
        :'client_key' => :'String',
        :'tls_validation' => :'Boolean',
        :'username' => :'String',
        :'password' => :'String',
        :'pulp_label_select' => :'String'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
        :'domain',
        :'ca_cert',
        :'client_cert',
        :'client_key',
        :'username',
        :'password',
        :'pulp_label_select'
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `PulpcoreClient::UpstreamPulp` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `PulpcoreClient::UpstreamPulp`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.key?(:'base_url')
        self.base_url = attributes[:'base_url']
      end

      if attributes.key?(:'api_root')
        self.api_root = attributes[:'api_root']
      end

      if attributes.key?(:'domain')
        self.domain = attributes[:'domain']
      end

      if attributes.key?(:'ca_cert')
        self.ca_cert = attributes[:'ca_cert']
      end

      if attributes.key?(:'client_cert')
        self.client_cert = attributes[:'client_cert']
      end

      if attributes.key?(:'client_key')
        self.client_key = attributes[:'client_key']
      end

      if attributes.key?(:'tls_validation')
        self.tls_validation = attributes[:'tls_validation']
      end

      if attributes.key?(:'username')
        self.username = attributes[:'username']
      end

      if attributes.key?(:'password')
        self.password = attributes[:'password']
      end

      if attributes.key?(:'pulp_label_select')
        self.pulp_label_select = attributes[:'pulp_label_select']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @name.nil?
        invalid_properties.push('invalid value for "name", name cannot be nil.')
      end

      if @name.to_s.length < 1
        invalid_properties.push('invalid value for "name", the character length must be great than or equal to 1.')
      end

      if @base_url.nil?
        invalid_properties.push('invalid value for "base_url", base_url cannot be nil.')
      end

      if @base_url.to_s.length < 1
        invalid_properties.push('invalid value for "base_url", the character length must be great than or equal to 1.')
      end

      if @api_root.nil?
        invalid_properties.push('invalid value for "api_root", api_root cannot be nil.')
      end

      if @api_root.to_s.length < 1
        invalid_properties.push('invalid value for "api_root", the character length must be great than or equal to 1.')
      end

      if !@domain.nil? && @domain.to_s.length < 1
        invalid_properties.push('invalid value for "domain", the character length must be great than or equal to 1.')
      end

      if !@ca_cert.nil? && @ca_cert.to_s.length < 1
        invalid_properties.push('invalid value for "ca_cert", the character length must be great than or equal to 1.')
      end

      if !@client_cert.nil? && @client_cert.to_s.length < 1
        invalid_properties.push('invalid value for "client_cert", the character length must be great than or equal to 1.')
      end

      if !@client_key.nil? && @client_key.to_s.length < 1
        invalid_properties.push('invalid value for "client_key", the character length must be great than or equal to 1.')
      end

      if !@username.nil? && @username.to_s.length < 1
        invalid_properties.push('invalid value for "username", the character length must be great than or equal to 1.')
      end

      if !@password.nil? && @password.to_s.length < 1
        invalid_properties.push('invalid value for "password", the character length must be great than or equal to 1.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @name.nil?
      return false if @name.to_s.length < 1
      return false if @base_url.nil?
      return false if @base_url.to_s.length < 1
      return false if @api_root.nil?
      return false if @api_root.to_s.length < 1
      return false if !@domain.nil? && @domain.to_s.length < 1
      return false if !@ca_cert.nil? && @ca_cert.to_s.length < 1
      return false if !@client_cert.nil? && @client_cert.to_s.length < 1
      return false if !@client_key.nil? && @client_key.to_s.length < 1
      return false if !@username.nil? && @username.to_s.length < 1
      return false if !@password.nil? && @password.to_s.length < 1
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] name Value to be assigned
    def name=(name)
      if name.nil?
        fail ArgumentError, 'name cannot be nil'
      end

      if name.to_s.length < 1
        fail ArgumentError, 'invalid value for "name", the character length must be great than or equal to 1.'
      end

      @name = name
    end

    # Custom attribute writer method with validation
    # @param [Object] base_url Value to be assigned
    def base_url=(base_url)
      if base_url.nil?
        fail ArgumentError, 'base_url cannot be nil'
      end

      if base_url.to_s.length < 1
        fail ArgumentError, 'invalid value for "base_url", the character length must be great than or equal to 1.'
      end

      @base_url = base_url
    end

    # Custom attribute writer method with validation
    # @param [Object] api_root Value to be assigned
    def api_root=(api_root)
      if api_root.nil?
        fail ArgumentError, 'api_root cannot be nil'
      end

      if api_root.to_s.length < 1
        fail ArgumentError, 'invalid value for "api_root", the character length must be great than or equal to 1.'
      end

      @api_root = api_root
    end

    # Custom attribute writer method with validation
    # @param [Object] domain Value to be assigned
    def domain=(domain)
      if !domain.nil? && domain.to_s.length < 1
        fail ArgumentError, 'invalid value for "domain", the character length must be great than or equal to 1.'
      end

      @domain = domain
    end

    # Custom attribute writer method with validation
    # @param [Object] ca_cert Value to be assigned
    def ca_cert=(ca_cert)
      if !ca_cert.nil? && ca_cert.to_s.length < 1
        fail ArgumentError, 'invalid value for "ca_cert", the character length must be great than or equal to 1.'
      end

      @ca_cert = ca_cert
    end

    # Custom attribute writer method with validation
    # @param [Object] client_cert Value to be assigned
    def client_cert=(client_cert)
      if !client_cert.nil? && client_cert.to_s.length < 1
        fail ArgumentError, 'invalid value for "client_cert", the character length must be great than or equal to 1.'
      end

      @client_cert = client_cert
    end

    # Custom attribute writer method with validation
    # @param [Object] client_key Value to be assigned
    def client_key=(client_key)
      if !client_key.nil? && client_key.to_s.length < 1
        fail ArgumentError, 'invalid value for "client_key", the character length must be great than or equal to 1.'
      end

      @client_key = client_key
    end

    # Custom attribute writer method with validation
    # @param [Object] username Value to be assigned
    def username=(username)
      if !username.nil? && username.to_s.length < 1
        fail ArgumentError, 'invalid value for "username", the character length must be great than or equal to 1.'
      end

      @username = username
    end

    # Custom attribute writer method with validation
    # @param [Object] password Value to be assigned
    def password=(password)
      if !password.nil? && password.to_s.length < 1
        fail ArgumentError, 'invalid value for "password", the character length must be great than or equal to 1.'
      end

      @password = password
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          name == o.name &&
          base_url == o.base_url &&
          api_root == o.api_root &&
          domain == o.domain &&
          ca_cert == o.ca_cert &&
          client_cert == o.client_cert &&
          client_key == o.client_key &&
          tls_validation == o.tls_validation &&
          username == o.username &&
          password == o.password &&
          pulp_label_select == o.pulp_label_select
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [name, base_url, api_root, domain, ca_cert, client_cert, client_key, tls_validation, username, password, pulp_label_select].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        PulpcoreClient.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
